package com.jeequan.jeepay.core.model.params.fuioupay;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.jeequan.jeepay.core.annotate.ChannelMchId;
import com.jeequan.jeepay.core.constants.ChannelMchIdTypeEnum;
import com.jeequan.jeepay.core.model.params.IsvParams;
import com.jeequan.jeepay.core.utils.StringKit;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;

/*
 * 富友 配置信息
 *
 * @author zx
 *
 * @date 2022/3/8 18:02
 */
@Data
public class FuioupayIsvParams extends IsvParams {

    /** 是否沙箱环境  1-是 */
    private Byte sandbox;

    /** 机构号,接入机构在富友的唯一代码 **/
    @ChannelMchId(type = ChannelMchIdTypeEnum.ISV_NO)
    private String insCd;

    /** 机构编码（富友提供，4位），用于订单前缀 **/
    private String insCd4OrderPrefix;

    /** 终端号(没有真实终端号统一填88888888) **/
    private String termId;

    /** privateKey 私钥 **/
    private String privateKey;

    /** publicKey 富友公钥 **/
    private String publicKey;

    /** md5Key  进件密钥 **/
    private String md5Key;

    /** 进件ftp  帐号 **/
    private String applyFtpUser;

    /** 进件ftp  密码 **/
    private String applyFtpPwd;

    /** 分账ftp  帐号 **/
    private String shareFtpUser;

    /** 分账ftp  密码 **/
    private String shareFtpPwd;

    /** 公众号appid **/
    private String wxAppid;

    /** 小程序appid **/
    private String wxLiteAppid;

    /** 【云秘POS】ymSysId **/
    private String ymSysId;

    /** 【云秘POS】ymPosMd5Key 密钥 **/
    private String ymPosMd5Key;

    /** ymPosPrivateKey 【云秘POS】私钥 **/
    private String ymPosPrivateKey;

    /** ymPosPublicKey 【云秘POS】富友公钥 **/
    private String ymPosPublicKey;

    @Override
    public String deSenData() {

        FuioupayIsvParams isvParams = this;
        if (StringUtils.isNotBlank(this.privateKey)) {
            isvParams.setPrivateKey(StringKit.autoDesensitization(this.privateKey));
        }
        if (StringUtils.isNotBlank(this.publicKey)) {
            isvParams.setPublicKey(StringKit.autoDesensitization(this.publicKey));
        }
        if (StringUtils.isNotBlank(this.md5Key)) {
            isvParams.setMd5Key(StringKit.autoDesensitization(this.md5Key));
        }
        if (StringUtils.isNotBlank(this.applyFtpPwd)) {
            isvParams.setApplyFtpPwd(StringKit.autoDesensitization(this.applyFtpPwd));
        }
        if (StringUtils.isNotBlank(this.shareFtpPwd)) {
            isvParams.setShareFtpPwd(StringKit.autoDesensitization(this.shareFtpPwd));
        }
        if (StringUtils.isNotBlank(this.ymPosPrivateKey)) {
            isvParams.setYmPosPrivateKey(StringKit.autoDesensitization(this.ymPosPrivateKey));
        }
        if (StringUtils.isNotBlank(this.ymPosPublicKey)) {
            isvParams.setYmPosPublicKey(StringKit.autoDesensitization(this.ymPosPublicKey));
        }
        if (StringUtils.isNotBlank(this.ymPosMd5Key)) {
            isvParams.setYmPosMd5Key(StringKit.autoDesensitization(this.ymPosMd5Key));
        }
        return ((JSONObject) JSON.toJSON(isvParams)).toJSONString();
    }

}
